// Code generated by SQLBoiler 4.14.2 (https://github.com/volatiletech/sqlboiler). DO NOT EDIT.
// This file is meant to be re-generated in place and/or deleted at any time.

package models

import (
	"context"
	"database/sql"
	"fmt"
	"reflect"
	"strconv"
	"strings"
	"sync"
	"time"

	"github.com/friendsofgo/errors"
	"github.com/volatiletech/null/v8"
	"github.com/volatiletech/sqlboiler/v4/boil"
	"github.com/volatiletech/sqlboiler/v4/queries"
	"github.com/volatiletech/sqlboiler/v4/queries/qm"
	"github.com/volatiletech/sqlboiler/v4/queries/qmhelper"
	"github.com/volatiletech/strmangle"
)

// AddPaymentsVehicle is an object representing the database table.
type AddPaymentsVehicle struct {
	ID             int64      `boil:"id" json:"id" toml:"id" yaml:"id"`
	IDVehicle      null.Int64 `boil:"id_vehicle" json:"id_vehicle,omitempty" toml:"id_vehicle" yaml:"id_vehicle,omitempty"`
	Amount         null.Int   `boil:"amount" json:"amount,omitempty" toml:"amount" yaml:"amount,omitempty"`
	DateAddPayment null.Time  `boil:"date_add_payment" json:"date_add_payment,omitempty" toml:"date_add_payment" yaml:"date_add_payment,omitempty"`
	CreatedAt      time.Time  `boil:"created_at" json:"created_at" toml:"created_at" yaml:"created_at"`
	UpdatedAt      time.Time  `boil:"updated_at" json:"updated_at" toml:"updated_at" yaml:"updated_at"`

	R *addPaymentsVehicleR `boil:"-" json:"-" toml:"-" yaml:"-"`
	L addPaymentsVehicleL  `boil:"-" json:"-" toml:"-" yaml:"-"`
}

var AddPaymentsVehicleColumns = struct {
	ID             string
	IDVehicle      string
	Amount         string
	DateAddPayment string
	CreatedAt      string
	UpdatedAt      string
}{
	ID:             "id",
	IDVehicle:      "id_vehicle",
	Amount:         "amount",
	DateAddPayment: "date_add_payment",
	CreatedAt:      "created_at",
	UpdatedAt:      "updated_at",
}

var AddPaymentsVehicleTableColumns = struct {
	ID             string
	IDVehicle      string
	Amount         string
	DateAddPayment string
	CreatedAt      string
	UpdatedAt      string
}{
	ID:             "add_payments_vehicle.id",
	IDVehicle:      "add_payments_vehicle.id_vehicle",
	Amount:         "add_payments_vehicle.amount",
	DateAddPayment: "add_payments_vehicle.date_add_payment",
	CreatedAt:      "add_payments_vehicle.created_at",
	UpdatedAt:      "add_payments_vehicle.updated_at",
}

// Generated where

var AddPaymentsVehicleWhere = struct {
	ID             whereHelperint64
	IDVehicle      whereHelpernull_Int64
	Amount         whereHelpernull_Int
	DateAddPayment whereHelpernull_Time
	CreatedAt      whereHelpertime_Time
	UpdatedAt      whereHelpertime_Time
}{
	ID:             whereHelperint64{field: "\"add_payments_vehicle\".\"id\""},
	IDVehicle:      whereHelpernull_Int64{field: "\"add_payments_vehicle\".\"id_vehicle\""},
	Amount:         whereHelpernull_Int{field: "\"add_payments_vehicle\".\"amount\""},
	DateAddPayment: whereHelpernull_Time{field: "\"add_payments_vehicle\".\"date_add_payment\""},
	CreatedAt:      whereHelpertime_Time{field: "\"add_payments_vehicle\".\"created_at\""},
	UpdatedAt:      whereHelpertime_Time{field: "\"add_payments_vehicle\".\"updated_at\""},
}

// AddPaymentsVehicleRels is where relationship names are stored.
var AddPaymentsVehicleRels = struct {
	IDVehicleOrderVehicle string
}{
	IDVehicleOrderVehicle: "IDVehicleOrderVehicle",
}

// addPaymentsVehicleR is where relationships are stored.
type addPaymentsVehicleR struct {
	IDVehicleOrderVehicle *OrderVehicle `boil:"IDVehicleOrderVehicle" json:"IDVehicleOrderVehicle" toml:"IDVehicleOrderVehicle" yaml:"IDVehicleOrderVehicle"`
}

// NewStruct creates a new relationship struct
func (*addPaymentsVehicleR) NewStruct() *addPaymentsVehicleR {
	return &addPaymentsVehicleR{}
}

func (r *addPaymentsVehicleR) GetIDVehicleOrderVehicle() *OrderVehicle {
	if r == nil {
		return nil
	}
	return r.IDVehicleOrderVehicle
}

// addPaymentsVehicleL is where Load methods for each relationship are stored.
type addPaymentsVehicleL struct{}

var (
	addPaymentsVehicleAllColumns            = []string{"id", "id_vehicle", "amount", "date_add_payment", "created_at", "updated_at"}
	addPaymentsVehicleColumnsWithoutDefault = []string{}
	addPaymentsVehicleColumnsWithDefault    = []string{"id", "id_vehicle", "amount", "date_add_payment", "created_at", "updated_at"}
	addPaymentsVehiclePrimaryKeyColumns     = []string{"id"}
	addPaymentsVehicleGeneratedColumns      = []string{}
)

type (
	// AddPaymentsVehicleSlice is an alias for a slice of pointers to AddPaymentsVehicle.
	// This should almost always be used instead of []AddPaymentsVehicle.
	AddPaymentsVehicleSlice []*AddPaymentsVehicle
	// AddPaymentsVehicleHook is the signature for custom AddPaymentsVehicle hook methods
	AddPaymentsVehicleHook func(context.Context, boil.ContextExecutor, *AddPaymentsVehicle) error

	addPaymentsVehicleQuery struct {
		*queries.Query
	}
)

// Cache for insert, update and upsert
var (
	addPaymentsVehicleType                 = reflect.TypeOf(&AddPaymentsVehicle{})
	addPaymentsVehicleMapping              = queries.MakeStructMapping(addPaymentsVehicleType)
	addPaymentsVehiclePrimaryKeyMapping, _ = queries.BindMapping(addPaymentsVehicleType, addPaymentsVehicleMapping, addPaymentsVehiclePrimaryKeyColumns)
	addPaymentsVehicleInsertCacheMut       sync.RWMutex
	addPaymentsVehicleInsertCache          = make(map[string]insertCache)
	addPaymentsVehicleUpdateCacheMut       sync.RWMutex
	addPaymentsVehicleUpdateCache          = make(map[string]updateCache)
	addPaymentsVehicleUpsertCacheMut       sync.RWMutex
	addPaymentsVehicleUpsertCache          = make(map[string]insertCache)
)

var (
	// Force time package dependency for automated UpdatedAt/CreatedAt.
	_ = time.Second
	// Force qmhelper dependency for where clause generation (which doesn't
	// always happen)
	_ = qmhelper.Where
)

var addPaymentsVehicleAfterSelectHooks []AddPaymentsVehicleHook

var addPaymentsVehicleBeforeInsertHooks []AddPaymentsVehicleHook
var addPaymentsVehicleAfterInsertHooks []AddPaymentsVehicleHook

var addPaymentsVehicleBeforeUpdateHooks []AddPaymentsVehicleHook
var addPaymentsVehicleAfterUpdateHooks []AddPaymentsVehicleHook

var addPaymentsVehicleBeforeDeleteHooks []AddPaymentsVehicleHook
var addPaymentsVehicleAfterDeleteHooks []AddPaymentsVehicleHook

var addPaymentsVehicleBeforeUpsertHooks []AddPaymentsVehicleHook
var addPaymentsVehicleAfterUpsertHooks []AddPaymentsVehicleHook

// doAfterSelectHooks executes all "after Select" hooks.
func (o *AddPaymentsVehicle) doAfterSelectHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range addPaymentsVehicleAfterSelectHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doBeforeInsertHooks executes all "before insert" hooks.
func (o *AddPaymentsVehicle) doBeforeInsertHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range addPaymentsVehicleBeforeInsertHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doAfterInsertHooks executes all "after Insert" hooks.
func (o *AddPaymentsVehicle) doAfterInsertHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range addPaymentsVehicleAfterInsertHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doBeforeUpdateHooks executes all "before Update" hooks.
func (o *AddPaymentsVehicle) doBeforeUpdateHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range addPaymentsVehicleBeforeUpdateHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doAfterUpdateHooks executes all "after Update" hooks.
func (o *AddPaymentsVehicle) doAfterUpdateHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range addPaymentsVehicleAfterUpdateHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doBeforeDeleteHooks executes all "before Delete" hooks.
func (o *AddPaymentsVehicle) doBeforeDeleteHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range addPaymentsVehicleBeforeDeleteHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doAfterDeleteHooks executes all "after Delete" hooks.
func (o *AddPaymentsVehicle) doAfterDeleteHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range addPaymentsVehicleAfterDeleteHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doBeforeUpsertHooks executes all "before Upsert" hooks.
func (o *AddPaymentsVehicle) doBeforeUpsertHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range addPaymentsVehicleBeforeUpsertHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doAfterUpsertHooks executes all "after Upsert" hooks.
func (o *AddPaymentsVehicle) doAfterUpsertHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range addPaymentsVehicleAfterUpsertHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// AddAddPaymentsVehicleHook registers your hook function for all future operations.
func AddAddPaymentsVehicleHook(hookPoint boil.HookPoint, addPaymentsVehicleHook AddPaymentsVehicleHook) {
	switch hookPoint {
	case boil.AfterSelectHook:
		addPaymentsVehicleAfterSelectHooks = append(addPaymentsVehicleAfterSelectHooks, addPaymentsVehicleHook)
	case boil.BeforeInsertHook:
		addPaymentsVehicleBeforeInsertHooks = append(addPaymentsVehicleBeforeInsertHooks, addPaymentsVehicleHook)
	case boil.AfterInsertHook:
		addPaymentsVehicleAfterInsertHooks = append(addPaymentsVehicleAfterInsertHooks, addPaymentsVehicleHook)
	case boil.BeforeUpdateHook:
		addPaymentsVehicleBeforeUpdateHooks = append(addPaymentsVehicleBeforeUpdateHooks, addPaymentsVehicleHook)
	case boil.AfterUpdateHook:
		addPaymentsVehicleAfterUpdateHooks = append(addPaymentsVehicleAfterUpdateHooks, addPaymentsVehicleHook)
	case boil.BeforeDeleteHook:
		addPaymentsVehicleBeforeDeleteHooks = append(addPaymentsVehicleBeforeDeleteHooks, addPaymentsVehicleHook)
	case boil.AfterDeleteHook:
		addPaymentsVehicleAfterDeleteHooks = append(addPaymentsVehicleAfterDeleteHooks, addPaymentsVehicleHook)
	case boil.BeforeUpsertHook:
		addPaymentsVehicleBeforeUpsertHooks = append(addPaymentsVehicleBeforeUpsertHooks, addPaymentsVehicleHook)
	case boil.AfterUpsertHook:
		addPaymentsVehicleAfterUpsertHooks = append(addPaymentsVehicleAfterUpsertHooks, addPaymentsVehicleHook)
	}
}

// One returns a single addPaymentsVehicle record from the query.
func (q addPaymentsVehicleQuery) One(ctx context.Context, exec boil.ContextExecutor) (*AddPaymentsVehicle, error) {
	o := &AddPaymentsVehicle{}

	queries.SetLimit(q.Query, 1)

	err := q.Bind(ctx, exec, o)
	if err != nil {
		if errors.Is(err, sql.ErrNoRows) {
			return nil, sql.ErrNoRows
		}
		return nil, errors.Wrap(err, "models: failed to execute a one query for add_payments_vehicle")
	}

	if err := o.doAfterSelectHooks(ctx, exec); err != nil {
		return o, err
	}

	return o, nil
}

// All returns all AddPaymentsVehicle records from the query.
func (q addPaymentsVehicleQuery) All(ctx context.Context, exec boil.ContextExecutor) (AddPaymentsVehicleSlice, error) {
	var o []*AddPaymentsVehicle

	err := q.Bind(ctx, exec, &o)
	if err != nil {
		return nil, errors.Wrap(err, "models: failed to assign all query results to AddPaymentsVehicle slice")
	}

	if len(addPaymentsVehicleAfterSelectHooks) != 0 {
		for _, obj := range o {
			if err := obj.doAfterSelectHooks(ctx, exec); err != nil {
				return o, err
			}
		}
	}

	return o, nil
}

// Count returns the count of all AddPaymentsVehicle records in the query.
func (q addPaymentsVehicleQuery) Count(ctx context.Context, exec boil.ContextExecutor) (int64, error) {
	var count int64

	queries.SetSelect(q.Query, nil)
	queries.SetCount(q.Query)

	err := q.Query.QueryRowContext(ctx, exec).Scan(&count)
	if err != nil {
		return 0, errors.Wrap(err, "models: failed to count add_payments_vehicle rows")
	}

	return count, nil
}

// Exists checks if the row exists in the table.
func (q addPaymentsVehicleQuery) Exists(ctx context.Context, exec boil.ContextExecutor) (bool, error) {
	var count int64

	queries.SetSelect(q.Query, nil)
	queries.SetCount(q.Query)
	queries.SetLimit(q.Query, 1)

	err := q.Query.QueryRowContext(ctx, exec).Scan(&count)
	if err != nil {
		return false, errors.Wrap(err, "models: failed to check if add_payments_vehicle exists")
	}

	return count > 0, nil
}

// IDVehicleOrderVehicle pointed to by the foreign key.
func (o *AddPaymentsVehicle) IDVehicleOrderVehicle(mods ...qm.QueryMod) orderVehicleQuery {
	queryMods := []qm.QueryMod{
		qm.Where("\"id\" = ?", o.IDVehicle),
	}

	queryMods = append(queryMods, mods...)

	return OrderVehicles(queryMods...)
}

// LoadIDVehicleOrderVehicle allows an eager lookup of values, cached into the
// loaded structs of the objects. This is for an N-1 relationship.
func (addPaymentsVehicleL) LoadIDVehicleOrderVehicle(ctx context.Context, e boil.ContextExecutor, singular bool, maybeAddPaymentsVehicle interface{}, mods queries.Applicator) error {
	var slice []*AddPaymentsVehicle
	var object *AddPaymentsVehicle

	if singular {
		var ok bool
		object, ok = maybeAddPaymentsVehicle.(*AddPaymentsVehicle)
		if !ok {
			object = new(AddPaymentsVehicle)
			ok = queries.SetFromEmbeddedStruct(&object, &maybeAddPaymentsVehicle)
			if !ok {
				return errors.New(fmt.Sprintf("failed to set %T from embedded struct %T", object, maybeAddPaymentsVehicle))
			}
		}
	} else {
		s, ok := maybeAddPaymentsVehicle.(*[]*AddPaymentsVehicle)
		if ok {
			slice = *s
		} else {
			ok = queries.SetFromEmbeddedStruct(&slice, maybeAddPaymentsVehicle)
			if !ok {
				return errors.New(fmt.Sprintf("failed to set %T from embedded struct %T", slice, maybeAddPaymentsVehicle))
			}
		}
	}

	args := make([]interface{}, 0, 1)
	if singular {
		if object.R == nil {
			object.R = &addPaymentsVehicleR{}
		}
		if !queries.IsNil(object.IDVehicle) {
			args = append(args, object.IDVehicle)
		}

	} else {
	Outer:
		for _, obj := range slice {
			if obj.R == nil {
				obj.R = &addPaymentsVehicleR{}
			}

			for _, a := range args {
				if queries.Equal(a, obj.IDVehicle) {
					continue Outer
				}
			}

			if !queries.IsNil(obj.IDVehicle) {
				args = append(args, obj.IDVehicle)
			}

		}
	}

	if len(args) == 0 {
		return nil
	}

	query := NewQuery(
		qm.From(`order_vehicle`),
		qm.WhereIn(`order_vehicle.id in ?`, args...),
	)
	if mods != nil {
		mods.Apply(query)
	}

	results, err := query.QueryContext(ctx, e)
	if err != nil {
		return errors.Wrap(err, "failed to eager load OrderVehicle")
	}

	var resultSlice []*OrderVehicle
	if err = queries.Bind(results, &resultSlice); err != nil {
		return errors.Wrap(err, "failed to bind eager loaded slice OrderVehicle")
	}

	if err = results.Close(); err != nil {
		return errors.Wrap(err, "failed to close results of eager load for order_vehicle")
	}
	if err = results.Err(); err != nil {
		return errors.Wrap(err, "error occurred during iteration of eager loaded relations for order_vehicle")
	}

	if len(orderVehicleAfterSelectHooks) != 0 {
		for _, obj := range resultSlice {
			if err := obj.doAfterSelectHooks(ctx, e); err != nil {
				return err
			}
		}
	}

	if len(resultSlice) == 0 {
		return nil
	}

	if singular {
		foreign := resultSlice[0]
		object.R.IDVehicleOrderVehicle = foreign
		if foreign.R == nil {
			foreign.R = &orderVehicleR{}
		}
		foreign.R.IDVehicleAddPaymentsVehicles = append(foreign.R.IDVehicleAddPaymentsVehicles, object)
		return nil
	}

	for _, local := range slice {
		for _, foreign := range resultSlice {
			if queries.Equal(local.IDVehicle, foreign.ID) {
				local.R.IDVehicleOrderVehicle = foreign
				if foreign.R == nil {
					foreign.R = &orderVehicleR{}
				}
				foreign.R.IDVehicleAddPaymentsVehicles = append(foreign.R.IDVehicleAddPaymentsVehicles, local)
				break
			}
		}
	}

	return nil
}

// SetIDVehicleOrderVehicle of the addPaymentsVehicle to the related item.
// Sets o.R.IDVehicleOrderVehicle to related.
// Adds o to related.R.IDVehicleAddPaymentsVehicles.
func (o *AddPaymentsVehicle) SetIDVehicleOrderVehicle(ctx context.Context, exec boil.ContextExecutor, insert bool, related *OrderVehicle) error {
	var err error
	if insert {
		if err = related.Insert(ctx, exec, boil.Infer()); err != nil {
			return errors.Wrap(err, "failed to insert into foreign table")
		}
	}

	updateQuery := fmt.Sprintf(
		"UPDATE \"add_payments_vehicle\" SET %s WHERE %s",
		strmangle.SetParamNames("\"", "\"", 1, []string{"id_vehicle"}),
		strmangle.WhereClause("\"", "\"", 2, addPaymentsVehiclePrimaryKeyColumns),
	)
	values := []interface{}{related.ID, o.ID}

	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, updateQuery)
		fmt.Fprintln(writer, values)
	}
	if _, err = exec.ExecContext(ctx, updateQuery, values...); err != nil {
		return errors.Wrap(err, "failed to update local table")
	}

	queries.Assign(&o.IDVehicle, related.ID)
	if o.R == nil {
		o.R = &addPaymentsVehicleR{
			IDVehicleOrderVehicle: related,
		}
	} else {
		o.R.IDVehicleOrderVehicle = related
	}

	if related.R == nil {
		related.R = &orderVehicleR{
			IDVehicleAddPaymentsVehicles: AddPaymentsVehicleSlice{o},
		}
	} else {
		related.R.IDVehicleAddPaymentsVehicles = append(related.R.IDVehicleAddPaymentsVehicles, o)
	}

	return nil
}

// RemoveIDVehicleOrderVehicle relationship.
// Sets o.R.IDVehicleOrderVehicle to nil.
// Removes o from all passed in related items' relationships struct.
func (o *AddPaymentsVehicle) RemoveIDVehicleOrderVehicle(ctx context.Context, exec boil.ContextExecutor, related *OrderVehicle) error {
	var err error

	queries.SetScanner(&o.IDVehicle, nil)
	if _, err = o.Update(ctx, exec, boil.Whitelist("id_vehicle")); err != nil {
		return errors.Wrap(err, "failed to update local table")
	}

	if o.R != nil {
		o.R.IDVehicleOrderVehicle = nil
	}
	if related == nil || related.R == nil {
		return nil
	}

	for i, ri := range related.R.IDVehicleAddPaymentsVehicles {
		if queries.Equal(o.IDVehicle, ri.IDVehicle) {
			continue
		}

		ln := len(related.R.IDVehicleAddPaymentsVehicles)
		if ln > 1 && i < ln-1 {
			related.R.IDVehicleAddPaymentsVehicles[i] = related.R.IDVehicleAddPaymentsVehicles[ln-1]
		}
		related.R.IDVehicleAddPaymentsVehicles = related.R.IDVehicleAddPaymentsVehicles[:ln-1]
		break
	}
	return nil
}

// AddPaymentsVehicles retrieves all the records using an executor.
func AddPaymentsVehicles(mods ...qm.QueryMod) addPaymentsVehicleQuery {
	mods = append(mods, qm.From("\"add_payments_vehicle\""))
	q := NewQuery(mods...)
	if len(queries.GetSelect(q)) == 0 {
		queries.SetSelect(q, []string{"\"add_payments_vehicle\".*"})
	}

	return addPaymentsVehicleQuery{q}
}

// FindAddPaymentsVehicle retrieves a single record by ID with an executor.
// If selectCols is empty Find will return all columns.
func FindAddPaymentsVehicle(ctx context.Context, exec boil.ContextExecutor, iD int64, selectCols ...string) (*AddPaymentsVehicle, error) {
	addPaymentsVehicleObj := &AddPaymentsVehicle{}

	sel := "*"
	if len(selectCols) > 0 {
		sel = strings.Join(strmangle.IdentQuoteSlice(dialect.LQ, dialect.RQ, selectCols), ",")
	}
	query := fmt.Sprintf(
		"select %s from \"add_payments_vehicle\" where \"id\"=$1", sel,
	)

	q := queries.Raw(query, iD)

	err := q.Bind(ctx, exec, addPaymentsVehicleObj)
	if err != nil {
		if errors.Is(err, sql.ErrNoRows) {
			return nil, sql.ErrNoRows
		}
		return nil, errors.Wrap(err, "models: unable to select from add_payments_vehicle")
	}

	if err = addPaymentsVehicleObj.doAfterSelectHooks(ctx, exec); err != nil {
		return addPaymentsVehicleObj, err
	}

	return addPaymentsVehicleObj, nil
}

// Insert a single record using an executor.
// See boil.Columns.InsertColumnSet documentation to understand column list inference for inserts.
func (o *AddPaymentsVehicle) Insert(ctx context.Context, exec boil.ContextExecutor, columns boil.Columns) error {
	if o == nil {
		return errors.New("models: no add_payments_vehicle provided for insertion")
	}

	var err error
	if !boil.TimestampsAreSkipped(ctx) {
		currTime := time.Now().In(boil.GetLocation())

		if o.CreatedAt.IsZero() {
			o.CreatedAt = currTime
		}
		if o.UpdatedAt.IsZero() {
			o.UpdatedAt = currTime
		}
	}

	if err := o.doBeforeInsertHooks(ctx, exec); err != nil {
		return err
	}

	nzDefaults := queries.NonZeroDefaultSet(addPaymentsVehicleColumnsWithDefault, o)

	key := makeCacheKey(columns, nzDefaults)
	addPaymentsVehicleInsertCacheMut.RLock()
	cache, cached := addPaymentsVehicleInsertCache[key]
	addPaymentsVehicleInsertCacheMut.RUnlock()

	if !cached {
		wl, returnColumns := columns.InsertColumnSet(
			addPaymentsVehicleAllColumns,
			addPaymentsVehicleColumnsWithDefault,
			addPaymentsVehicleColumnsWithoutDefault,
			nzDefaults,
		)

		cache.valueMapping, err = queries.BindMapping(addPaymentsVehicleType, addPaymentsVehicleMapping, wl)
		if err != nil {
			return err
		}
		cache.retMapping, err = queries.BindMapping(addPaymentsVehicleType, addPaymentsVehicleMapping, returnColumns)
		if err != nil {
			return err
		}
		if len(wl) != 0 {
			cache.query = fmt.Sprintf("INSERT INTO \"add_payments_vehicle\" (\"%s\") %%sVALUES (%s)%%s", strings.Join(wl, "\",\""), strmangle.Placeholders(dialect.UseIndexPlaceholders, len(wl), 1, 1))
		} else {
			cache.query = "INSERT INTO \"add_payments_vehicle\" %sDEFAULT VALUES%s"
		}

		var queryOutput, queryReturning string

		if len(cache.retMapping) != 0 {
			queryReturning = fmt.Sprintf(" RETURNING \"%s\"", strings.Join(returnColumns, "\",\""))
		}

		cache.query = fmt.Sprintf(cache.query, queryOutput, queryReturning)
	}

	value := reflect.Indirect(reflect.ValueOf(o))
	vals := queries.ValuesFromMapping(value, cache.valueMapping)

	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, cache.query)
		fmt.Fprintln(writer, vals)
	}

	if len(cache.retMapping) != 0 {
		err = exec.QueryRowContext(ctx, cache.query, vals...).Scan(queries.PtrsFromMapping(value, cache.retMapping)...)
	} else {
		_, err = exec.ExecContext(ctx, cache.query, vals...)
	}

	if err != nil {
		return errors.Wrap(err, "models: unable to insert into add_payments_vehicle")
	}

	if !cached {
		addPaymentsVehicleInsertCacheMut.Lock()
		addPaymentsVehicleInsertCache[key] = cache
		addPaymentsVehicleInsertCacheMut.Unlock()
	}

	return o.doAfterInsertHooks(ctx, exec)
}

// Update uses an executor to update the AddPaymentsVehicle.
// See boil.Columns.UpdateColumnSet documentation to understand column list inference for updates.
// Update does not automatically update the record in case of default values. Use .Reload() to refresh the records.
func (o *AddPaymentsVehicle) Update(ctx context.Context, exec boil.ContextExecutor, columns boil.Columns) (int64, error) {
	if !boil.TimestampsAreSkipped(ctx) {
		currTime := time.Now().In(boil.GetLocation())

		o.UpdatedAt = currTime
	}

	var err error
	if err = o.doBeforeUpdateHooks(ctx, exec); err != nil {
		return 0, err
	}
	key := makeCacheKey(columns, nil)
	addPaymentsVehicleUpdateCacheMut.RLock()
	cache, cached := addPaymentsVehicleUpdateCache[key]
	addPaymentsVehicleUpdateCacheMut.RUnlock()

	if !cached {
		wl := columns.UpdateColumnSet(
			addPaymentsVehicleAllColumns,
			addPaymentsVehiclePrimaryKeyColumns,
		)

		if !columns.IsWhitelist() {
			wl = strmangle.SetComplement(wl, []string{"created_at"})
		}
		if len(wl) == 0 {
			return 0, errors.New("models: unable to update add_payments_vehicle, could not build whitelist")
		}

		cache.query = fmt.Sprintf("UPDATE \"add_payments_vehicle\" SET %s WHERE %s",
			strmangle.SetParamNames("\"", "\"", 1, wl),
			strmangle.WhereClause("\"", "\"", len(wl)+1, addPaymentsVehiclePrimaryKeyColumns),
		)
		cache.valueMapping, err = queries.BindMapping(addPaymentsVehicleType, addPaymentsVehicleMapping, append(wl, addPaymentsVehiclePrimaryKeyColumns...))
		if err != nil {
			return 0, err
		}
	}

	values := queries.ValuesFromMapping(reflect.Indirect(reflect.ValueOf(o)), cache.valueMapping)

	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, cache.query)
		fmt.Fprintln(writer, values)
	}
	var result sql.Result
	result, err = exec.ExecContext(ctx, cache.query, values...)
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to update add_payments_vehicle row")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "models: failed to get rows affected by update for add_payments_vehicle")
	}

	if !cached {
		addPaymentsVehicleUpdateCacheMut.Lock()
		addPaymentsVehicleUpdateCache[key] = cache
		addPaymentsVehicleUpdateCacheMut.Unlock()
	}

	return rowsAff, o.doAfterUpdateHooks(ctx, exec)
}

// UpdateAll updates all rows with the specified column values.
func (q addPaymentsVehicleQuery) UpdateAll(ctx context.Context, exec boil.ContextExecutor, cols M) (int64, error) {
	queries.SetUpdate(q.Query, cols)

	result, err := q.Query.ExecContext(ctx, exec)
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to update all for add_payments_vehicle")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to retrieve rows affected for add_payments_vehicle")
	}

	return rowsAff, nil
}

// UpdateAll updates all rows with the specified column values, using an executor.
func (o AddPaymentsVehicleSlice) UpdateAll(ctx context.Context, exec boil.ContextExecutor, cols M) (int64, error) {
	ln := int64(len(o))
	if ln == 0 {
		return 0, nil
	}

	if len(cols) == 0 {
		return 0, errors.New("models: update all requires at least one column argument")
	}

	colNames := make([]string, len(cols))
	args := make([]interface{}, len(cols))

	i := 0
	for name, value := range cols {
		colNames[i] = name
		args[i] = value
		i++
	}

	// Append all of the primary key values for each column
	for _, obj := range o {
		pkeyArgs := queries.ValuesFromMapping(reflect.Indirect(reflect.ValueOf(obj)), addPaymentsVehiclePrimaryKeyMapping)
		args = append(args, pkeyArgs...)
	}

	sql := fmt.Sprintf("UPDATE \"add_payments_vehicle\" SET %s WHERE %s",
		strmangle.SetParamNames("\"", "\"", 1, colNames),
		strmangle.WhereClauseRepeated(string(dialect.LQ), string(dialect.RQ), len(colNames)+1, addPaymentsVehiclePrimaryKeyColumns, len(o)))

	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, sql)
		fmt.Fprintln(writer, args...)
	}
	result, err := exec.ExecContext(ctx, sql, args...)
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to update all in addPaymentsVehicle slice")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to retrieve rows affected all in update all addPaymentsVehicle")
	}
	return rowsAff, nil
}

// Upsert attempts an insert using an executor, and does an update or ignore on conflict.
// See boil.Columns documentation for how to properly use updateColumns and insertColumns.
func (o *AddPaymentsVehicle) Upsert(ctx context.Context, exec boil.ContextExecutor, updateOnConflict bool, conflictColumns []string, updateColumns, insertColumns boil.Columns) error {
	if o == nil {
		return errors.New("models: no add_payments_vehicle provided for upsert")
	}
	if !boil.TimestampsAreSkipped(ctx) {
		currTime := time.Now().In(boil.GetLocation())

		if o.CreatedAt.IsZero() {
			o.CreatedAt = currTime
		}
		o.UpdatedAt = currTime
	}

	if err := o.doBeforeUpsertHooks(ctx, exec); err != nil {
		return err
	}

	nzDefaults := queries.NonZeroDefaultSet(addPaymentsVehicleColumnsWithDefault, o)

	// Build cache key in-line uglily - mysql vs psql problems
	buf := strmangle.GetBuffer()
	if updateOnConflict {
		buf.WriteByte('t')
	} else {
		buf.WriteByte('f')
	}
	buf.WriteByte('.')
	for _, c := range conflictColumns {
		buf.WriteString(c)
	}
	buf.WriteByte('.')
	buf.WriteString(strconv.Itoa(updateColumns.Kind))
	for _, c := range updateColumns.Cols {
		buf.WriteString(c)
	}
	buf.WriteByte('.')
	buf.WriteString(strconv.Itoa(insertColumns.Kind))
	for _, c := range insertColumns.Cols {
		buf.WriteString(c)
	}
	buf.WriteByte('.')
	for _, c := range nzDefaults {
		buf.WriteString(c)
	}
	key := buf.String()
	strmangle.PutBuffer(buf)

	addPaymentsVehicleUpsertCacheMut.RLock()
	cache, cached := addPaymentsVehicleUpsertCache[key]
	addPaymentsVehicleUpsertCacheMut.RUnlock()

	var err error

	if !cached {
		insert, ret := insertColumns.InsertColumnSet(
			addPaymentsVehicleAllColumns,
			addPaymentsVehicleColumnsWithDefault,
			addPaymentsVehicleColumnsWithoutDefault,
			nzDefaults,
		)

		update := updateColumns.UpdateColumnSet(
			addPaymentsVehicleAllColumns,
			addPaymentsVehiclePrimaryKeyColumns,
		)

		if updateOnConflict && len(update) == 0 {
			return errors.New("models: unable to upsert add_payments_vehicle, could not build update column list")
		}

		conflict := conflictColumns
		if len(conflict) == 0 {
			conflict = make([]string, len(addPaymentsVehiclePrimaryKeyColumns))
			copy(conflict, addPaymentsVehiclePrimaryKeyColumns)
		}
		cache.query = buildUpsertQueryPostgres(dialect, "\"add_payments_vehicle\"", updateOnConflict, ret, update, conflict, insert)

		cache.valueMapping, err = queries.BindMapping(addPaymentsVehicleType, addPaymentsVehicleMapping, insert)
		if err != nil {
			return err
		}
		if len(ret) != 0 {
			cache.retMapping, err = queries.BindMapping(addPaymentsVehicleType, addPaymentsVehicleMapping, ret)
			if err != nil {
				return err
			}
		}
	}

	value := reflect.Indirect(reflect.ValueOf(o))
	vals := queries.ValuesFromMapping(value, cache.valueMapping)
	var returns []interface{}
	if len(cache.retMapping) != 0 {
		returns = queries.PtrsFromMapping(value, cache.retMapping)
	}

	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, cache.query)
		fmt.Fprintln(writer, vals)
	}
	if len(cache.retMapping) != 0 {
		err = exec.QueryRowContext(ctx, cache.query, vals...).Scan(returns...)
		if errors.Is(err, sql.ErrNoRows) {
			err = nil // Postgres doesn't return anything when there's no update
		}
	} else {
		_, err = exec.ExecContext(ctx, cache.query, vals...)
	}
	if err != nil {
		return errors.Wrap(err, "models: unable to upsert add_payments_vehicle")
	}

	if !cached {
		addPaymentsVehicleUpsertCacheMut.Lock()
		addPaymentsVehicleUpsertCache[key] = cache
		addPaymentsVehicleUpsertCacheMut.Unlock()
	}

	return o.doAfterUpsertHooks(ctx, exec)
}

// Delete deletes a single AddPaymentsVehicle record with an executor.
// Delete will match against the primary key column to find the record to delete.
func (o *AddPaymentsVehicle) Delete(ctx context.Context, exec boil.ContextExecutor) (int64, error) {
	if o == nil {
		return 0, errors.New("models: no AddPaymentsVehicle provided for delete")
	}

	if err := o.doBeforeDeleteHooks(ctx, exec); err != nil {
		return 0, err
	}

	args := queries.ValuesFromMapping(reflect.Indirect(reflect.ValueOf(o)), addPaymentsVehiclePrimaryKeyMapping)
	sql := "DELETE FROM \"add_payments_vehicle\" WHERE \"id\"=$1"

	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, sql)
		fmt.Fprintln(writer, args...)
	}
	result, err := exec.ExecContext(ctx, sql, args...)
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to delete from add_payments_vehicle")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "models: failed to get rows affected by delete for add_payments_vehicle")
	}

	if err := o.doAfterDeleteHooks(ctx, exec); err != nil {
		return 0, err
	}

	return rowsAff, nil
}

// DeleteAll deletes all matching rows.
func (q addPaymentsVehicleQuery) DeleteAll(ctx context.Context, exec boil.ContextExecutor) (int64, error) {
	if q.Query == nil {
		return 0, errors.New("models: no addPaymentsVehicleQuery provided for delete all")
	}

	queries.SetDelete(q.Query)

	result, err := q.Query.ExecContext(ctx, exec)
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to delete all from add_payments_vehicle")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "models: failed to get rows affected by deleteall for add_payments_vehicle")
	}

	return rowsAff, nil
}

// DeleteAll deletes all rows in the slice, using an executor.
func (o AddPaymentsVehicleSlice) DeleteAll(ctx context.Context, exec boil.ContextExecutor) (int64, error) {
	if len(o) == 0 {
		return 0, nil
	}

	if len(addPaymentsVehicleBeforeDeleteHooks) != 0 {
		for _, obj := range o {
			if err := obj.doBeforeDeleteHooks(ctx, exec); err != nil {
				return 0, err
			}
		}
	}

	var args []interface{}
	for _, obj := range o {
		pkeyArgs := queries.ValuesFromMapping(reflect.Indirect(reflect.ValueOf(obj)), addPaymentsVehiclePrimaryKeyMapping)
		args = append(args, pkeyArgs...)
	}

	sql := "DELETE FROM \"add_payments_vehicle\" WHERE " +
		strmangle.WhereClauseRepeated(string(dialect.LQ), string(dialect.RQ), 1, addPaymentsVehiclePrimaryKeyColumns, len(o))

	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, sql)
		fmt.Fprintln(writer, args)
	}
	result, err := exec.ExecContext(ctx, sql, args...)
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to delete all from addPaymentsVehicle slice")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "models: failed to get rows affected by deleteall for add_payments_vehicle")
	}

	if len(addPaymentsVehicleAfterDeleteHooks) != 0 {
		for _, obj := range o {
			if err := obj.doAfterDeleteHooks(ctx, exec); err != nil {
				return 0, err
			}
		}
	}

	return rowsAff, nil
}

// Reload refetches the object from the database
// using the primary keys with an executor.
func (o *AddPaymentsVehicle) Reload(ctx context.Context, exec boil.ContextExecutor) error {
	ret, err := FindAddPaymentsVehicle(ctx, exec, o.ID)
	if err != nil {
		return err
	}

	*o = *ret
	return nil
}

// ReloadAll refetches every row with matching primary key column values
// and overwrites the original object slice with the newly updated slice.
func (o *AddPaymentsVehicleSlice) ReloadAll(ctx context.Context, exec boil.ContextExecutor) error {
	if o == nil || len(*o) == 0 {
		return nil
	}

	slice := AddPaymentsVehicleSlice{}
	var args []interface{}
	for _, obj := range *o {
		pkeyArgs := queries.ValuesFromMapping(reflect.Indirect(reflect.ValueOf(obj)), addPaymentsVehiclePrimaryKeyMapping)
		args = append(args, pkeyArgs...)
	}

	sql := "SELECT \"add_payments_vehicle\".* FROM \"add_payments_vehicle\" WHERE " +
		strmangle.WhereClauseRepeated(string(dialect.LQ), string(dialect.RQ), 1, addPaymentsVehiclePrimaryKeyColumns, len(*o))

	q := queries.Raw(sql, args...)

	err := q.Bind(ctx, exec, &slice)
	if err != nil {
		return errors.Wrap(err, "models: unable to reload all in AddPaymentsVehicleSlice")
	}

	*o = slice

	return nil
}

// AddPaymentsVehicleExists checks if the AddPaymentsVehicle row exists.
func AddPaymentsVehicleExists(ctx context.Context, exec boil.ContextExecutor, iD int64) (bool, error) {
	var exists bool
	sql := "select exists(select 1 from \"add_payments_vehicle\" where \"id\"=$1 limit 1)"

	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, sql)
		fmt.Fprintln(writer, iD)
	}
	row := exec.QueryRowContext(ctx, sql, iD)

	err := row.Scan(&exists)
	if err != nil {
		return false, errors.Wrap(err, "models: unable to check if add_payments_vehicle exists")
	}

	return exists, nil
}

// Exists checks if the AddPaymentsVehicle row exists.
func (o *AddPaymentsVehicle) Exists(ctx context.Context, exec boil.ContextExecutor) (bool, error) {
	return AddPaymentsVehicleExists(ctx, exec, o.ID)
}
